#include "MUICatEdit.h"

struct MonCatalogue *mc       = NULL;

void AfficheErreur(char *message)
{
    if(app && win)
        MUI_Request(app,win,0,NULL,GetString(MSG_Ok),message);
    else
        FermeTout(message,10);
}

void OuvreCatalogue(void)
{
    STRPTR erreur;
    
    if(!(mc=LitCatalogue((STRPTR) arguments[0],&erreur)))
        AfficheErreur(erreur);
}

void FermeCatalogue(void)
{
    if(mc) LibereCatalogue(mc);
}

char htoa(UBYTE n)
{
    switch(n)
    {
        case  0: return('0');
        case  1: return('1');
        case  2: return('2');
        case  3: return('3');
        case  4: return('4');
        case  5: return('5');
        case  6: return('6');
        case  7: return('7');
        case  8: return('8');
        case  9: return('9');
        case 10: return('a');
        case 11: return('b');
        case 12: return('c');
        case 13: return('d');
        case 14: return('e');
        case 15: return('f');
    }
    return('?');
}

void hextoc(char *to, UBYTE from)
{
    *to++='\\';
    *to++='x';
    *to++=htoa(from/16);
    *to++=htoa(from%16);
    *to='\0';
}

BOOL ConstruitCatChaine(ULONG *buffer,ULONG taille,struct MonCatalogue *mc)
{
    struct CatChaine *ptr;
    char *chaine,temp[10];
    ULONG *fin;
    int compteur=0,i;
    LONG len,num,end;
    BOOL erreur=FALSE;
    UBYTE *string=NULL;
    
    fin=(ULONG *) ((LONG) buffer+(LONG)taille);
    ptr=&mc->mc_TeteChaine;
    
    mc->mc_Tableau=NULL;
    
    while((!erreur) && (buffer<fin))
    {
        compteur++;
        if(ptr->cc_Next=malloc(sizeof(struct CatChaine)))
        {
            ptr->cc_Next->cc_Num=*buffer++;
            len=*buffer++;
            string=(UBYTE *)buffer;
            if(chaine=malloc(len*4+1))
            {
                if(len%4==1 && (UBYTE)string[len-1]=='\0')
                    end=len-1;
                else
                    end=len;
                chaine[0]='\0';
                for(i=0; i<end; i++)
                {
                    if(string[i]==7)
                        strcat(chaine,"\\a");
                    else if(string[i]==8)
                        strcat(chaine,"\\b");
                    else if(string[i]==155)
                        strcat(chaine,"\\c");
                    else if(string[i]==27)
                        strcat(chaine,"\\e");
                    else if(string[i]==12)
                        strcat(chaine,"\\f");
                    else if(string[i]==10)
                        strcat(chaine,"\\n");
                    else if(string[i]==13)
                        strcat(chaine,"\\r");
                    else if(string[i]==9)
                        strcat(chaine,"\\t");
                    else if(string[i]==11)
                        strcat(chaine,"\\v");
                    else if(string[i]=='\\')
                        strcat(chaine,"\\\\");
                    else if(string[i]>=0 && string[i]<=31)
                    {
                        hextoc(temp,string[i]);
                        strcat(chaine,temp);
                    }
                    else
                    {
                        sprintf(temp,"%c",string[i]);
                        strcat(chaine,temp);
                    }
                }
                if(ptr->cc_Next->cc_Chaine=malloc(strlen(chaine)+1))
                {
                    strcpy(ptr->cc_Next->cc_Chaine,chaine);
                    buffer+=1+len/sizeof(*buffer);
                }
                else erreur=TRUE;
                free(chaine);
            }
            else erreur=TRUE;
            
            if(erreur) free(ptr->cc_Next);
        }
        else erreur=TRUE;

        if(!erreur) ptr=ptr->cc_Next;
    }
    ptr->cc_Next=NULL;
    if(erreur) return(FALSE);
    
    if(!(mc->mc_Tableau=malloc((compteur+1)*sizeof(char **))))
        return(FALSE);
        
    num=0;
    ptr=mc->mc_TeteChaine.cc_Next;
    
    while((!erreur) && (num<compteur))
    {
        if(!(mc->mc_Tableau[num]=malloc(sizeof(char)*arguments[1])))
        {
            erreur=TRUE;
            for(i=0; i<num; i++)
                free(mc->mc_Tableau[i]);
            free(mc->mc_Tableau);
        }
        else
        {
            strcpy(mc->mc_Tableau[num],ptr->cc_Chaine);
            ptr=ptr->cc_Next;
        }
        num++;
    }
    if(erreur) return(FALSE);

    mc->mc_Nombre=compteur;
    mc->mc_Tableau[compteur]=NULL;
    return(TRUE);
    
}

struct MonCatalogue *LitCatalogue(STRPTR fichier,char **erreur)
{
    struct IFFHandle      *iff=NULL;
    struct StoredProperty *sp1=NULL;
    struct StoredProperty *sp2=NULL;
    struct StoredProperty *sp3=NULL;
    struct ContextNode    *top=NULL;
    
    ULONG               *buffer=NULL;
    struct MonCatalogue *mc    =NULL;
    *erreur=NULL;
    
    if(!(mc=malloc(sizeof(struct MonCatalogue))))
    {
        *erreur=GetString(MSG_ERROR_NOMEM);
        return(NULL);
    }
    mc->mc_TeteChaine.cc_Next=NULL;
    mc->mc_Tableau=NULL;
    
    if(iff=AllocIFF())
    {
        if(iff->iff_Stream=Open(fichier,MODE_OLDFILE))
        {
            InitIFFasDOS(iff);
            if(!OpenIFF(iff,IFFF_READ))
            {
                if(!(PropChunk(iff, ID_CTLG, ID_FVER) ||
                     PropChunk(iff, ID_CTLG, ID_LANG) ||
                     PropChunk(iff, ID_CTLG, ID_CSET) ||
                     StopChunk(iff, ID_CTLG, ID_STRS) ||
                     ParseIFF(iff,IFFPARSE_SCAN)))
                {
                    if( (sp1=FindProp(iff,ID_CTLG,ID_FVER)) &&
                        (sp2=FindProp(iff,ID_CTLG,ID_LANG)) &&
                        (sp3=FindProp(iff,ID_CTLG,ID_CSET)) )
                    {
                        memcpy(mc->mc_Version, sp1->sp_Data, sp1->sp_Size);
                        memcpy(mc->mc_Langage, sp2->sp_Data, sp2->sp_Size);
                        memcpy(mc->mc_CSET,    sp3->sp_Data, sp3->sp_Size);
                        mc->mc_Version[sp1->sp_Size+1]='\0';
                        mc->mc_Langage[sp2->sp_Size+1]='\0';
                        mc->mc_CSETLen=sp3->sp_Size;
                        
                        top=CurrentChunk(iff);
                        if(top->cn_ID==ID_STRS)
                        {
                            if(buffer=malloc(top->cn_Size))
                            {
                                if(ReadChunkBytes(iff,buffer,top->cn_Size)==top->cn_Size)
                                {
                                    if(!ConstruitCatChaine(buffer,top->cn_Size,mc))
                                        *erreur=GetString(MSG_ERROR_NOMEM);
                                }
                                else *erreur=GetString(MSG_ERROR_IFFSTRUCTURE);
                                free(buffer);
                            }
                            else *erreur=GetString(MSG_ERROR_NOMEM);
                        }
                        else *erreur=GetString(MSG_ERROR_UNEXPECTEDDATA);
                    }
                    else *erreur=GetString(MSG_ERROR_CONSULTATION);
                }
                else *erreur=GetString(MSG_ERROR_INCORRECTCATALOG);
                CloseIFF(iff);
            }
            else *erreur=GetString(MSG_ERROR_OPENIFF);
            Close(iff->iff_Stream);
        }
        else *erreur=GetString(MSG_ERROR_OPENFILE);
        FreeIFF(iff);
    }
    else *erreur=GetString(MSG_ERROR_ALLOCIFF);
    
    if(*erreur)
    {
        LibereCatalogue(mc);
        return(NULL);
    }
    else
        return(mc);
}

void LibereCatalogue(struct MonCatalogue *mc)
{
    struct CatChaine *ptr   = mc->mc_TeteChaine.cc_Next;
    struct CatChaine *oldptr=&mc->mc_TeteChaine;
    int i;
    
    if(!mc) return;
    
    while(ptr)
    {
        oldptr=ptr;
        free(ptr->cc_Chaine);
        ptr=ptr->cc_Next;
        free(oldptr);
    }
    if(mc->mc_Tableau)
    {
        for(i=0; i<mc->mc_Nombre; i++)
            free(mc->mc_Tableau[i]);
        free(mc->mc_Tableau);
    }
}

void EcritCatalogue(struct MonCatalogue *mc,STRPTR fichier)
{
    struct IFFHandle *iff=NULL;
    struct CatChaine *cc;
    char             *string=NULL,*erreur=NULL;
    char              temp[4];
    LONG              compteur=0;
    LONG              len,i,j;
    int               valhex;
    
    if(iff=AllocIFF())
    {
        if(iff->iff_Stream=Open(fichier,MODE_NEWFILE))
        {
            InitIFFasDOS(iff);
            if(!OpenIFF(iff,IFFF_WRITE))
            {
                if(!PushChunk(iff, ID_CTLG, ID_FORM, IFFSIZE_UNKNOWN))
                {
                    if(!PushChunk(iff, ID_CTLG, ID_FVER, IFFSIZE_UNKNOWN))
                    {
                        WriteChunkBytes(iff, mc->mc_Version, strlen(mc->mc_Version)+1);
                        PopChunk(iff);
                    }
                    if(!PushChunk(iff, ID_CTLG, ID_LANG, IFFSIZE_UNKNOWN))
                    {
                        WriteChunkBytes(iff, (APTR) mc->mc_Langage, strlen(mc->mc_Langage)+1);
                        PopChunk(iff);
                    }
                    if(!PushChunk(iff, ID_CTLG, ID_CSET, IFFSIZE_UNKNOWN))
                    {
                        WriteChunkBytes(iff, mc->mc_CSET, mc->mc_CSETLen);
                        PopChunk(iff);
                    }
                    if(!PushChunk(iff, ID_CTLG, ID_STRS, IFFSIZE_UNKNOWN))
                    {
                        cc=mc->mc_TeteChaine.cc_Next;
                        while(cc && !erreur)
                        {
                            WriteChunkBytes(iff, &cc->cc_Num, sizeof(cc->cc_Num));
                            len=strlen(mc->mc_Tableau[compteur]);
                            if(string=malloc(len))
                            {
                                i=j=0;
                                while(i<len && !erreur)
                                {
                                    if(mc->mc_Tableau[compteur][i]=='\\')
                                    {
                                        switch(mc->mc_Tableau[compteur][++i])
                                        {
                                            case 'a':
                                                i++;
                                                string[j++]='\a';
                                                break;
                                            case 'b':
                                                i++;
                                                string[j++]='\b';
                                                break;
                                            case 'c':
                                                i++;
                                                string[j++]='\x9b';
                                                break;
                                            case 'e':
                                                i++;
                                                string[j++]='\x1b';
                                                break;
                                            case 'f':
                                                i++;
                                                string[j++]='\f';
                                                break;
                                            case 'n':
                                                i++;
                                                string[j++]='\n';
                                                break;
                                            case 'r':
                                                i++;
                                                string[j++]='\r';
                                                break;
                                            case 't':
                                                i++;
                                                string[j++]='\t';
                                                break;
                                            case 'v':
                                                i++;
                                                string[j++]='\v';
                                                break;
                                            case '\\':
                                                i++;
                                                string[j++]='\\';
                                                break;
                                            case 'x':
                                                i++;
                                                if(isxdigit(mc->mc_Tableau[compteur][i]) &&
                                                   isxdigit(mc->mc_Tableau[compteur][i+1]))
                                                {
                                                    temp[0]=mc->mc_Tableau[compteur][i++];
                                                    temp[1]=mc->mc_Tableau[compteur][i++];
                                                    temp[2]='\0';
                                                    stch_i(temp,&valhex);
                                                    string[j++]=(UBYTE) valhex;
                                                }
                                                else
                                                {
                                                    erreur=GetString(MSG_ERROR_INVALID_BACKSLASH);
                                                    ListUpdate(mc->mc_Tableau[compteur],compteur);
                                                }
                                                break;
                                            default:
                                                if(isdigit(mc->mc_Tableau[compteur][i]) &&
                                                   isdigit(mc->mc_Tableau[compteur][i+1]) &&
                                                   isdigit(mc->mc_Tableau[compteur][i+2]))
                                                { 
                                                    temp[0]=mc->mc_Tableau[compteur][i++];
                                                    temp[1]=mc->mc_Tableau[compteur][i++];
                                                    temp[2]=mc->mc_Tableau[compteur][i++];
                                                    temp[3]='\0';
                                                    stcd_i(temp,&valhex);
                                                    string[j++]=(UBYTE) valhex;
                                                }
                                                else
                                                {
                                                    string[j++]='\\';
                                                    string[j++]=mc->mc_Tableau[compteur][i-1];
                                                }
                                                break;
                                        }
                                    }
                                    else
                                        string[j++]=mc->mc_Tableau[compteur][i++];
                                }
                                string[j]='\0';
                                
                                len=j;
                                if(len%4)
                                {
                                    WriteChunkBytes(iff, &len, sizeof(len));
                                    len++;
                                }
                                else
                                {
                                    len++;
                                    WriteChunkBytes(iff, &len, sizeof(len));
                                }
                                if(!erreur)
                                    WriteChunkBytes(iff, string,len);
                                
                                while(len%4)
                                {
                                        len++;
                                    WriteChunkBytes(iff,'\0',1);
                                }
                                free(string);
                            }
                            else erreur=GetString(MSG_ERROR_NOMEM);
                            
                            compteur++;
                            cc=cc->cc_Next;
                        }
                        PopChunk(iff);
                    }
                    PopChunk(iff);
                }
            }
            else erreur=GetString(MSG_ERROR_OPENIFF);
            Close(iff->iff_Stream);
        }
        else erreur=GetString(MSG_ERROR_OPENFILE);
        FreeIFF(iff);
    }
    else erreur=GetString(MSG_ERROR_ALLOCIFF);
    
    if(erreur)
        AfficheErreur(erreur);
    else
        MUI_Request(app,win,0,NULL,GetString(MSG_Ok),GetString(MSG_CTLGFile_Written));
}

void EcritDescription(struct MonCatalogue *mc,STRPTR fichier)
{
    FILE *file;
    int compteur=0;
    struct CatChaine *cc;
    
    cc=mc->mc_TeteChaine.cc_Next;
    
    if(file=fopen(fichier,"wb"))
    {
        fprintf(file,"; version %s\n; language %s\n",mc->mc_Version, mc->mc_Langage);
        while(cc)
        {
            fprintf(file,"MSG_%ld (%ld//)\n%s\n;\n",cc->cc_Num,cc->cc_Num,mc->mc_Tableau[compteur]);
            
            compteur++;
            cc=cc->cc_Next;
        }
        fclose(file);
        MUI_Request(app,win,0,NULL,GetString(MSG_Ok),GetString(MSG_CDFile_Written));
    }
    else AfficheErreur(GetString(MSG_ERROR_OPENFILE));
}
