/*******************************************\
*               Include Files               *
\*******************************************/

/* ANSI C */

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <ctype.h>

/* MUI */
#include <libraries/mui.h>
#include <pragmas/muimaster_pragmas.h>

/* System */
#include <dos/dos.h>
#include <exec/exec.h>
#include <intuition/intuition.h>
#include <libraries/asl.h>
#include <libraries/iffparse.h>
#include <libraries/locale.h>

/* Prototypes */
#include <clib/alib_protos.h>
#include <clib/asl_protos.h>
#include <clib/dos_protos.h>
#include <clib/exec_protos.h>
#include <clib/iffparse_protos.h>
#include <clib/intuition_protos.h>
#include <clib/locale_protos.h>
#include <clib/muimaster_protos.h>

/*******************************************\
*                   #define                 *
\*******************************************/

#define CATALOG_NAME "muicatedit.catalog"

#define ID_STR2LIST   1
#define ID_LIST2STR   2
#define ID_SAVE       3
#define ID_LOAD       4
#define ID_QUIT       5
#define ID_STRVER     6
#define ID_STRLANG    7
#define ID_WINFIND    8
#define ID_WINREPL    9
#define ID_CDES      10
#define ID_FINDFIRST 11
#define ID_FINDNEXT  12
#define ID_REPLFIRST 13
#define ID_REPLNEXT  14
#define ID_REPLALL   15

#define MAX_CHAINE  512

#define ID_CTLG MAKE_ID('C','T','L','G')
#define ID_FVER MAKE_ID('F','V','E','R')
#define ID_LANG MAKE_ID('L','A','N','G')
#define ID_CSET MAKE_ID('C','S','E','T')
#define ID_STRS MAKE_ID('S','T','R','S')

/*******************************************\
*                 Localisation             *
\*******************************************/

#include "Locale.h"

/*******************************************\
*          Dfinitions des structures       *
\*******************************************/

struct CatChaine {
    struct CatChaine *cc_Next;
    LONG cc_Num;
    STRPTR cc_Chaine;
};

struct MonCatalogue {
    char   mc_Version[MAX_CHAINE];
    char   mc_Langage[MAX_CHAINE];
    char   mc_CSET[MAX_CHAINE];
    LONG   mc_CSETLen;
    struct CatChaine mc_TeteChaine;
    LONG   mc_Nombre;
    char   **mc_Tableau;
};

/*******************************************\
*                Prototypes                 *
\*******************************************/

/* arguments.c */
void LitArguments(void);
void LibereArguments(void);

/* asl.c */
BOOL DemandeFichierEntree(STRPTR);
BOOL DemandeFichierSortie(STRPTR);

/* cherche.c */
char *strstri(char *,char *);
LONG  ChercheMotMC(STRPTR, struct MonCatalogue *, LONG, char *(*)(char *,char *));
LONG  RemplaceMotMC(STRPTR, STRPTR, struct MonCatalogue *, LONG, char *(*)(char *,char *));
BOOL  RemplaceToutMotMC(STRPTR, STRPTR, char *, char *(*)(char *,char *));

/* locale.c */
void   OuvreLocale(void);
void   FermeLocale(void);
STRPTR GetString(int);

/* main.c */
void   OuvreBibliotheques(void);
void   FermeBibliotheques(void);
void   OuvreTout(void);
void   FermeTout(char *,int);
void   main(int,char **);

/* interface.c */
void   OuvreInterface(void);
void   FermeInterface(void);
void   GereInterface(void);
void   ListUpdate(char *,int);
void   ToggleWindow(APTR);
STRPTR ChaineNumero(struct MonCatalogue *,LONG);

/* litecrit.c */
void   OuvreCatalogue(void);
void   FermeCatalogue(void);
void   AfficheErreur(char *);
char   htoa(UBYTE);
void   hextoc(char *, UBYTE);
BOOL   ConstruitCatChaine(ULONG *,ULONG,struct MonCatalogue *);
struct MonCatalogue *LitCatalogue(STRPTR, char **);
void   LibereCatalogue(struct MonCatalogue *);
void   EcritCatalogue(struct MonCatalogue *,STRPTR);
void   EcritDescription(struct MonCatalogue *,STRPTR);

/*******************************************\
*            Variables globales             *
\*******************************************/

/* arguments.c */
extern LONG    arguments[2];
extern LONG    nbargs;
extern char    fichier_entree[MAX_CHAINE];
extern char    fichier_sortie[MAX_CHAINE];
extern char   *template;
extern struct  RDArgs *rdargs;

/* asl.c */

/* main.c */
extern struct IntuitionBase *IntuitionBase;
extern struct Library       *LocaleBase;
extern struct Library       *AslBase;
extern struct Library       *IffParseBase;
extern struct Library       *MUIMasterBase;

/* locale.c */
extern struct Catalog       *MyCatalog;

/* interface.c */
extern APTR app;
extern APTR win;
extern APTR listview;
extern APTR boutonload;
extern APTR boutonsave;
extern APTR boutonquit;
extern APTR boutoncata;
extern APTR boutonfind;
extern APTR boutonrepl;
extern APTR botuontout;
extern APTR string;
extern APTR stringver;
extern APTR stringlang;
extern BOOL sortie;

extern APTR boutonreplfirst;
extern APTR boutonreplnext;
extern APTR boutonreplall;
extern APTR boutonreplquit;
extern APTR stringrepl;
extern APTR stringby;
extern APTR replcheck;

extern APTR boutonfindfirst;
extern APTR boutonfindnext;
extern APTR boutonfindquit;
extern APTR stringfind;
extern APTR findcheck;

/* litecrit.c */
extern struct MonCatalogue *mc;
